<?php

function post_install()
{
    require_once 'modules/Administration/QuickRepairAndRebuild.php';

    echo "Performing first quick repair & rebuild ... <br>\n";
    $GLOBALS['log']->info('Need To Do Viewer Install: Performing first quick repair & rebuild');

    $autoexecute = false;
    $show_output = false;
    $randc = new RepairAndClear();
    $randc->repairAndClearAll(array('clearAll'), array(translate('LBL_ALL_MODULES')), $autoexecute, $show_output);

    echo "Performing second quick repair & rebuild ... <br>\n";
    $GLOBALS['log']->info('Need To Do Viewer Install: Performing second quick repair & rebuild');

    $autoexecute = false;
    $show_output = false;
    $randc = new RepairAndClear();
    $randc->repairAndClearAll(array('clearAll'), array(translate('LBL_ALL_MODULES')), $autoexecute, $show_output);

    echo "\nCreating \"Need To Do List Indexing\" Scheduler.<br />\n";
    $GLOBALS['log']->info('Need To Do Viewer Install: Creating "Need To Do List Indexing" Scheduler');

    $job = BeanFactory::getBean('Schedulers');
    $query = new SugarQuery();
    $query->from($job);
    $query->where()->equals('job', 'function::NtdvIndex');
    $query->select(array('id'));
    $schedulerId = $query->getOne();
    if (empty($schedulerId)) {
        global $timedate;
        $job->name = 'Need To Do List Indexing';
        $job->job = 'function::NtdvIndex';
        $job->date_time_start = $timedate->nowDb();
        $job->job_interval = '*/1::*::*::*::*';
        $job->status = 'Active';
        $job->catch_up = 1;
        $job->save();
    }

    echo "Running Sugar Outfitters Post Install Script ... <br>\n";
    $GLOBALS['log']->info('Need To Do Viewer Install: Running Sugar Outfitters Post Install Script');
    ntdv_sugar_outfitters_post_install_script();

    echo "Checking package configs ... <br>\n";
    require_once 'custom/PxRoutines/NeedToDoViewer/Package/Package.php';
    $packageControl = new \Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Package\Package();
    $GLOBALS['log']->info('Need To Do Viewer Install: Checking package installation date');
    $packageControl->setPackageInstallationDate();
//    $GLOBALS['log']->info('Need To Do Viewer Install: Checking package demo license token');
//    $packageControl->setDemoLicenseToken();

    echo "Start repairing roles ... <br>\n";
    $GLOBALS['log']->info('Need To Do Viewer Install: Repairing roles');
    $uw = isset($_REQUEST['upgradeWizard']) ? $_REQUEST['upgradeWizard'] : null;
    $_REQUEST['upgradeWizard'] = true;
    require "modules/ACL/install_actions.php";
    $_REQUEST['upgradeWizard'] = $uw;
    echo "End repairing roles ... <br>\n";

    echo "Rebuilding relationships ... <br>\n";
    $GLOBALS['log']->info('Need To Do Viewer Install: Rebuilding relationships');
    require_once 'data/Relationships/RelationshipFactory.php';
    SugarRelationshipFactory::rebuildCache();

    echo "Performing last quick repair & rebuild ... <br>\n";
    $GLOBALS['log']->info('Need To Do Viewer Install: Performing last quick repair & rebuild');

    $autoexecute = false;
    $show_output = false;
    $randc = new RepairAndClear();
    $randc->repairAndClearAll(array('clearAll'), array(translate('LBL_ALL_MODULES')), $autoexecute, $show_output);
}

function ntdv_sugar_outfitters_post_install_script()
{
    $db = DBManagerFactory::getInstance();
    if (!$db->tableExists('so_users')) {

        $fieldDefs = array(
            'id' => array(
                'name' => 'id',
                'vname' => 'LBL_ID',
                'type' => 'id',
                'required' => true,
                'reportable' => true,
            ),
            'deleted' => array(
                'name' => 'deleted',
                'vname' => 'LBL_DELETED',
                'type' => 'bool',
                'default' => '0',
                'reportable' => false,
                'comment' => 'Record deletion indicator',
            ),
            'shortname' => array(
                'name' => 'shortname',
                'vname' => 'LBL_SHORTNAME',
                'type' => 'varchar',
                'len' => 255,
            ),
            'user_id' => array(
                'name' => 'user_id',
                'rname' => 'user_name',
                'module' => 'Users',
                'id_name' => 'user_id',
                'vname' => 'LBL_USER_ID',
                'type' => 'relate',
                'isnull' => 'false',
                'dbType' => 'id',
                'reportable' => true,
                'massupdate' => false,
            ),
        );

        $indices = array(
            'id' => array(
                'name' => 'so_userspk',
                'type' => 'primary',
                'fields' => array(
                    0 => 'id',
                ),
            ),
            'shortname' => array(
                'name' => 'shortname',
                'type' => 'index',
                'fields' => array(
                    0 => 'shortname',
                ),
            ),
        );
        $db->createTableParams('so_users', $fieldDefs, $indices);
    }
}