<?php

require_once 'custom/PxRoutines/NeedToDoViewer/PX_NeedToDoEvents/visibility/NTDVSecurity.php';

class NTDVTeamSecurity implements NTDVSecurity{

    /**
     * @var PX_NeedToDoEvents
     */
    protected $ntdvEntity;

    public function __construct(PX_NeedToDoEvents $ntdvEntity){
        $this->ntdvEntity = $ntdvEntity;
    }

    public function applyParentSecurity(){
        if(empty($this->ntdvEntity->team_id)){
            $targetEntity = $this->ntdvEntity->getTargetEntityBean();
            if($this->validateTargetEntity($targetEntity)){
                $this->setTeamId($targetEntity);
                $this->setTeamSetId($targetEntity);
            }else{
                $this->ntdvEntity->team_id = '';
            }
        }
    }

    protected function validateTargetEntity($targetEntity){
        if(!empty($targetEntity) && $targetEntity instanceof SugarBean){
            if(isset($targetEntity->field_defs['team_id'])){
                return true;
            }
        }
        return false;
    }

    protected function setTeamId($targetEntity){
        if(!empty($targetEntity->team_id)){
            $this->ntdvEntity->team_id = $targetEntity->team_id;
        }else{
            $this->ntdvEntity->team_id = '';
        }
    }

    protected function setTeamSetId($targetEntity){
        if(!empty($targetEntity->team_set_id)){
            $this->ntdvEntity->team_set_id = $targetEntity->team_set_id;
        }
    }

}