<?php

namespace Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\PX_NeedToDoViewerComments\Helpers;

class SugarUrlGenerator{

    public function getSugarRecordUrl($module, $id = '')
    {
        $cleanUrl = $this->getSugarUrl();
        if (isModuleBWC($module)) {
            $url = $cleanUrl . "/index.php#bwc/index.php?module={$module}";
            if (!empty($id))
                $url .= "&action=DetailView&record={$id}";
        } else {
            $url = $cleanUrl . '/index.php#' . $module;
            if (!empty($id))
                $url .= "/{$id}";
        }

        return $url;
    }

    public function getSugarUrl()
    {
        global $sugar_config;
        $parsedSiteUrl = parse_url($sugar_config['site_url']);
        $host = $parsedSiteUrl['host'];
        if (!isset($parsedSiteUrl['port'])) {
            $parsedSiteUrl['port'] = 80;
        }
        $port = ($parsedSiteUrl['port'] != 80) ? ":" . $parsedSiteUrl['port'] : '';
        $path = !empty($parsedSiteUrl['path']) ? $parsedSiteUrl['path'] : "";
        $cleanUrl = "{$parsedSiteUrl['scheme']}://{$host}{$port}{$path}";

        return $cleanUrl;
    }

}