<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once 'clients/base/api/FileApi.php';

class PX_NeedToDoEventTypesFileTempApi extends FileTempApi {

    public function registerApiRest() {
        return array(
            'saveTempImagePost' => array(
                'reqType' => 'POST',
                'path' => array('PX_NeedToDoEventTypes', 'temp', 'file', '?'),
                'pathVars' => array('module', 'temp', '', 'field'),
                'method' => 'saveTempImagePost',
                'rawPostContents' => true,
                'shortHelp' => 'Saves an image to a temporary folder.',
                'longHelp' => 'include/api/help/module_temp_file_field_post_help.html',
            ),
            'getTempImage' => array(
                'reqType' => 'GET',
                'path' => array('PX_NeedToDoEventTypes', 'temp', 'file', '?', '?'),
                'pathVars' => array('module', 'record', '', 'field', 'temp_id'),
                'method' => 'getTempImage',
                'rawReply' => true,
                'allowDownloadCookie' => true,
                'shortHelp' => 'Reads a temporary image and deletes it.',
                'longHelp' => 'include/api/help/module_temp_file_field_temp_id_get_help.html',
            ),
        );
    }

    protected function loadBean(ServiceBase $api, array $args, $aclToCheck = 'view', array $options = array()) {
        $bean = parent::loadBean($api, $args, $aclToCheck, $options);

        if(!empty($args['field']) && $args['field'] == 'icon')
            $bean->field_defs[$args['field']]['type'] = 'image';

        return $bean;
    }
}
