({
    extendsFrom: 'IntField',

    initialize: function(options) {
        this._super('initialize', [options]);

        if(this.name == 'lifetime_duration') {
            this.listenTo(this.model, "change:lifetime_units", function (model, lifetimeUnits) {
                var validationTask = 'lifetime_duration_required';
                if (_.isEmpty(lifetimeUnits) || lifetimeUnits == 'Never') {
                    this.model.removeValidationTask(validationTask);
                    this.model.removeValidationTask('lifetime_duration_is_positive');
                    // this.setDisabled(true);
                } else {
                    app.error.errorName2Keys['lifetime_duration_is_positive'] = app.lang.get('MSG_LIFETIME_DURATION_MUST_BE_POSITIVE', this.module);
                    this.model.addValidationTask('lifetime_duration_is_positive', _.bind(function(fields, errors, callback){
                        var value = this.model.get('lifetime_duration');
                        if(_.isNumber(value) && !_.isNaN(value) && value <= 0){
                            errors.lifetime_duration = errors.lifetime_duration || {};
                            errors.lifetime_duration['lifetime_duration_is_positive'] = true;
                        }
                        callback(null, fields, errors);
                    }, this));

                    this.model.addValidationTask(validationTask, _.bind(function (fields, errors, callback) {
                        var value = this.model.get('lifetime_duration')
                        if(!_.isNumber(value) || _.isNaN(value) || !value){
                            errors.lifetime_duration = errors.lifetime_duration || {};
                            errors.lifetime_duration['required'] = true;
                        }
                        callback(null, fields, errors);
                    }, this));
                    // this.setDisabled(false);
                }
            }, this);
        }
    },

})
