<?php
 if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once 'modules/PX_NeedToDoEvents/clients/base/api/PX_NeedToDoEventsApi.php';
use Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\PX_NeedToDoEvents\helpers\NotifyUsersList;

class PX_NeedToDoEventsNotifyApi extends PX_NeedToDoEventsApi
{

    public function registerApiRest()
    {
        return array(
            'need_to_do_notify_list' => array(
                'reqType' => 'GET',
                'path' => array('pxntdv', 'notifications'),
                'pathVars' => array('', ''),
                'method' => 'getNeedToDoNotificationList',
                'shortHelp' => '',
                'longHelp' => '',
            ),
        );
    }

    public function getNeedToDoNotificationList(ServiceBase $api, array $args){
        try {
//            $thresholdDates = $this->getThresholdDates();
//            $list = $this->getNeedToDoListForNotification($api, $args, $thresholdDates);
            $list = $this->getNeedToDoEventsListForNotification($api, $args);
        }catch(Exception $e){

        }

        return $list;
    }

    protected function getNeedToDoEventsListForNotification($api, $args){
        global $timedate, $current_user;

        $query = $this->getNeedToDoEventQueryObject($api, $args);

//        $orWhere = $query->where()->queryOr();
//        $andWhere = $orWhere->queryAnd();
//        $andWhere->gte('notify_date', $timedate->now());

        $ntdvNotifyUsersTableAlias = "ntdv_notify_users_beforehand";
        $joinNtdvNotifyUsersSQL = "(SELECT id, event_id FROM px_ntdv_notify_users WHERE user_id = '" . $current_user->id . "' AND notified = " . NotifyUsersList::NOTIFICATION_ON_STATUS . ")";
        $query->join[$ntdvNotifyUsersTableAlias] = $query->joinTable($joinNtdvNotifyUsersSQL, array('alias' => $ntdvNotifyUsersTableAlias, 'joinType' => 'INNER'));
        $query->join[$ntdvNotifyUsersTableAlias]->on()->equalsField($ntdvNotifyUsersTableAlias . '.event_id', 'id');
        $query->select()->addField("$ntdvNotifyUsersTableAlias.id", array('alias' => 'ntdv_notify_users_id'));

        $toDatetime = $currentDatetimeStr = $timedate->nowDb();
//        $currentDatetimeObj = $timedate->getNow();
//        $interval = new DateInterval('PT30M');
//        $fromDatetime = $currentDatetimeObj->sub($interval);
//        if(!empty($fromDatetime)) {
//            $query->where()->gte('notify_date', $fromDatetime->format(TimeDate::DB_DATETIME_FORMAT));
//        }
        $query->where()->lte('notify_date', $toDatetime);

        $query->orderByReset();
        $query->orderBy('notify_date', 'DESC');
        $query->limit(1000);

//        $GLOBALS['log']->fatal('=========================================================');
//        $GLOBALS['log']->fatal('$query->compile()->getSQL(): ' . print_r($query->compile()->getSQL(), true));
//        $GLOBALS['log']->fatal('$query->compile()->getParameters(): ' . print_r($query->compile()->getParameters(), true));

        $result = $this->formatResult($api, $args, $query);

        $this->markEventNotificationsAsSent($result);
        return $result;
    }

    protected function markEventNotificationsAsSent($result){
        if(empty($result['records']) || !is_array($result['records']))
            return;

        $idsToMarkAsSent = array();
        foreach($result['records'] as $record){
            $idsToMarkAsSent[] = $record['ntdv_notify_users_id'];
        }

        if(!empty($idsToMarkAsSent)) {
            $db = \DBManagerFactory::getInstance();
            $sql = "UPDATE px_ntdv_notify_users SET notified=" . NotifyUsersList::NOTIFICATION_COMPLETED_STATUS . " WHERE id in ('" . implode("', '", $idsToMarkAsSent) . "')";
            $db->query($sql);
        }
    }

//    protected function getEventIdsForBeforehandNotification(){
//        global $timedate, $current_user;
//        $db = \DBManagerFactory::getInstance();
//        $sql = "
//                SELECT
//                    px_needtodoevents.id,
//                    px_needtodoevents.notify_date
//                FROM
//                    px_needtodoevents
//                INNER px_ntdv_notify_users
//                    ON
//                        px_ntdv_notify_users.event_id = px_needtodoevents.id
//                        px_ntdv_notify_users.notified = " . NotifyUsersList::NOTIFICATION_ON_STATUS . "
//                WHERE
//                    px_needtodoevents.deleted=0 AND
//                    px_ntdv_notify_users.user_id = '" . $current_user->id . "' AND
//                    px_needtodoevents.notify_date <= '" . $timedate->nowDb() . "'
//                ORDER BY px_needtodoevents.notify_date DESC
//                LIMIT 1000
//            ";
//        $rs = $db->query($sql);
//        $eventIds = array();
//        while($row = $db->fetchByAssoc($rs)){
//            $eventIds[] = $row['id'];
//        }
//        return $eventIds;
//    }
//
//
//
//
//    protected function getThresholdDates(){
//        $thresholdDates = array();
//        $eventTypes = $this->getNeedToDoEventTypes();
//        foreach($eventTypes as $eventType){
//            $thresholdDates[] = array(
//                'event_type_id' => $eventType['id'],
//                'notify_beforehand_date' => $this->getNotifyBeforehandDate($eventType),
//                'notify_overdue_date' => $this->getNotifyOverdueDate($eventType),
//            );
//        }
//
//        return $thresholdDates;
//    }
//
//    protected function getNeedToDoEventTypes(){
//        $query = new SugarQuery();
//        $query->from(BeanFactory::getBean('PX_NeedToDoEventTypes'));
//        $query->select(array(
//            'id',
//            'notify_beforehand',
//            'notify_beforehand_units',
//            'notify_beforehand_duration',
//            'notify_if_overdue'
//        ));
//        $orWhere = $query->where()->queryOr();
//        $andWhere = $orWhere->queryAnd();
//        $andWhere->equals('notify_beforehand', '1')->gt('notify_beforehand_duration', '0');
//        $orWhere->equals('notify_if_overdue', '1');
////        $GLOBALS['log']->fatal('$query->compile()->getSQL(): ' . print_r($query->compile()->getSQL(), true));
////        $GLOBALS['log']->fatal('$query->compile()->getParameters(): ' . print_r($query->compile()->getParameters(), true));
//        return $query->execute();
//    }
//
//    protected function getNotifyBeforehandDate($eventType){
//        global $timedate;
//
//        $lifetimeUnits = $eventType['notify_beforehand_units'];
//        $lifetimeDuration = $eventType['notify_beforehand_duration'];
//
//        if(!empty($eventType['notify_beforehand']) && !empty($lifetimeUnits) && !empty($lifetimeDuration)){
//            $interval = $this->getIntervalKey($lifetimeUnits, $lifetimeDuration);
//            $thresholdDate = $timedate->getNow();
//            $thresholdDate->sub(new DateInterval($interval));
//
//            return $thresholdDate->asDb();
//        }
//
//        return null;
//    }
//
//    protected function getIntervalKey($lifetimeUnits, $lifetimeDuration){
//        $number = abs($lifetimeDuration);
//        $interval = 'P';
//
//        if($lifetimeUnits == 'Years')
//            $interval .= $number . 'Y'; elseif($lifetimeUnits == 'Months')
//            $interval .= $number . 'M';
//        elseif($lifetimeUnits == 'Days')
//            $interval .= $number . 'D';
//        elseif($lifetimeUnits == 'Weeks')
//            $interval .= ($number * 7) . 'D';
//        elseif($lifetimeUnits == 'Hours')
//            $interval .= $number . 'h';
//        elseif($lifetimeUnits == 'Minutes')
//            $interval .= $number . 'i';
//
//        return $interval;
//    }
//
//    protected function getNotifyOverdueDate($eventType){
//        global $timedate;
//
//        if(!empty($eventType['notify_if_overdue'])){
//            $thresholdDate = $timedate->getNow();
//            return $thresholdDate->asDb();
//        }
//
//        return null;
//    }
//
//    protected function getNeedToDoListForNotification(ServiceBase $api, array $args, $thresholdDates){
//
//        $list = array();
////        $GLOBALS['log']->fatal('$thresholdDates: ' . print_r($thresholdDates, true));
//        foreach($thresholdDates as $thresholdDate){
//            if(!$this->validateThresholdDates($thresholdDate)){
//                continue;
//            }
//            $listByEventTypes = $this->getNeedToDoListForNotificationByEvent($api, $args, $thresholdDate);
//            if(!empty($listByEventTypes))
//            $list = array_merge_values($list, $listByEventTypes);
//        }
//
//        return $list;
//    }
//
//    protected function validateThresholdDates($params){
//        return !empty($params['event_type_id']) && (!empty($params['notify_beforehand_date']) || !empty($params['notify_overdue_date']));
//    }
//
//    protected function getNeedToDoListForNotificationByEvent(ServiceBase $api, array $args, $params){
//        global $timedate;
//        $previousDate = $timedate->fromIso($args['previous_date']);
//        if(empty($previousDate)) {
//            return array();
//        }else{
//            $previousDate = $previousDate->asDb();
//        }
//
//        $query = $this->getNeedToDoEventQueryObject($api, $params);
//
//        $query->where()->equals('event_type_id', $params['event_type_id']);
//        $query->where()->gte('control_date', $previousDate);
//
//        $orWhere = $query->where()->queryOr();
//        if(!empty($params['notify_beforehand_date'])) {
//            $orWhere->lte('control_date', $params['notify_beforehand_date']);
//        }
//        if(!empty($params['notify_beforehand_date'])) {
//            $orWhere->lte('control_date', $params['notify_overdue_date']);
//        }
//
////        $GLOBALS['log']->fatal('=========================================================');
////        $GLOBALS['log']->fatal('$query->compile()->getSQL(): ' . print_r($query->compile()->getSQL(), true));
////        $GLOBALS['log']->fatal('$query->compile()->getParameters(): ' . print_r($query->compile()->getParameters(), true));
//
//        $result = $this->formatResult($api, $args, $query);
//        return $result;
//    }
}
