({
    extendsFrom: "BaseField",

    formattedContextRelateList: [],

    initialize: function(arguments){
        this._super("initialize", [arguments]);

        Handlebars.registerHelper("ntdvBuildRecordsList", function(records){
            var recordUrls = [];

            _.each(records, function(record){
                var moduleName = record.moduleName || '',
                    recordId = record.recordId || '',
                    recordName = record.recordName || '';
                if(!_.isEmpty(moduleName) || !_.isEmpty(recordId) || !_.isEmpty(recordName)) {
                    recordUrls.push(
                        '<a href="#' + app.router.buildRoute(moduleName, recordId, '') + '">' + recordName +'</a>'
                    );
                }
            });

            return recordUrls.join(', ');
        });
    },

    formatContextRelateList: function(values){
        var defs = values || this.model.get(this.name);

        if(!_.isEmpty(defs) && _.isString(defs)){
            try{
                defs = JSON.parse(defs);
            }catch(err){
                defs = null;
                var errorMsg = app.lang.get('LBL_CONTEXT_RELATE_LIST_PARSE_ERROR', 'PX_NeedToDoEvents');
                app.logger.warn(errorMsg);
                if(!this.notifiedOfParseError) {
                    this.notifiedOfParseError = true;
                    app.alert.show('context_parse_error', {
                        level: 'warning',
                        messages: errorMsg
                    });
                }
            }
        }

        if(_.isEmpty(defs) || (_.isArray(defs) && defs.length <= 0) || (_.isString(defs) && defs == '[]')){
            return {};
        }

        return this.groupParentsList(defs);
    },

    groupParentsList: function(parentsList){
        parentsList = parentsList || this.model.get('parents_list');
        var groupedParentList = {};
        _.each(parentsList, function(parentItem){
            var moduleName = parentItem['moduleName'],
                linkName = parentItem['linkName'],
                linkLabel = parentItem['linkLabel'];
            groupedParentList[moduleName] = groupedParentList[moduleName] || {};
            groupedParentList[moduleName][linkLabel] = groupedParentList[moduleName][linkLabel] || {linkLabel: linkLabel, records: []};
            groupedParentList[moduleName][linkLabel]['records'].push(parentItem);
        });

        return groupedParentList;
    },

    bindDataChange: function() {
        if (this.model) {
            this.model.on("change:" + this.name, function(model, value) {
                this.render();
            }, this);
        }
    },

    _render: function(values) {
        this.formattedContextRelateList = this.formatContextRelateList();
        this._super('_render', [values]);
    },
})
