({

    extendsFrom: 'TabbedDashletView',

    // plugins: ['Dashlet'],

    events: {
        'click .sticky-group' : 'toggleGroupRecordsContainer',
        'click .sticky-item .show-comments-btn:not(.disabled)' : 'showCommentsInNeedToDoContainer',
        'click .sticky-item .context-btn:not(.disabled)' : 'contextToggledInNeedToDoContainer',

        // 'click [data-action=tab-switcher]': 'tabSwitcher'
        'click button.tab-switcher': 'tabSwitcher'
    },

    className: 'block filtered ntdv-layout',

    /**
     * The default settings for activity stream.
     *
     * @property {Object}
     */
    _defaultSettings: {
        limit: 5,
        auto_refresh: 0,
        filter_id: 'created_by_me',
        enable_sticking_features: 'bool_true',
        dashlet_height: 0,
        need_to_do_event_type_id: [],
        // visibility: 'current'
    },

    /**
     * Omnibar ActivityStream view
     */
    //omnibarView: null,

    lastProcessedDate: null,

    moduleIsAvailable: true,

    needToDoStatistics: {},
    statisticKeyFormat: 'YYYY-MM-DD',

    blacklistedModules: ['OAuthTokens', 'SchedulersJobs', 'Activities', 'vCals', 'KBArticles', 'KBDocuments', 'Forecasts', 'ForecastWorksheets', 'ForecastManagerWorksheets', 'Notifications','ActivityStream/Activities', 'ACLRoles', 'Teams', 'pmse_Project/pmse_BpmProcessDefinition', 'PX_NeedToDoEvents', 'PX_NeedToDoEventTypes', 'iFrames', 'Feeds', 'Dashboard', 'Calendar', 'pmse_Business_Rules', 'pmse_Project', 'pmse_Emails_Templates', 'pmse_Inbox'],
    needToDoEnabled: true,

    licenseStatus: null,
    licenseErrorLabel: '',

    targetNeedToDoElementTopPosition : 0,

    targetDatetimeFieldName: 'control_date',

    includeCurrentVisibility: false,
    includeOverdueVisibility: false,
    includeFutureVisibility: false,

    currentFilterObject: null,

    defaultToolBarHeight: 39,
    toolBarHeight: 39,

    quickActions: [],

    initialize: function(opts) {

        this.opts = opts;
        this.renderedNeedToDoItems = {};
        this.needToDoStatistics = {};
        this.plugins = ['Dashlet'];

        var contextModuleName = opts.context.parent.get('module'),
            moduleMeta = app.metadata.getModule(contextModuleName);
        this.needToDoEnabled = true;
        if(this.isDisabledForModule(contextModuleName)){
            this.needToDoEnabled = false;
        }else{
            this.plugins.push('Pagination');
        }

        this._super('initialize', [opts]);

        this.context.on('px-need-to-do-events:post:prepend', this.prependPost, this);

        if (this.needToDoEnabled && this.needToDoEnabled === true) {
            if (this.context.parent.get('layout') == 'records') {
                this.listenTo(this.context.parent.get('collection'), 'reset', function () {
                    this.resetStatisticsCount();
                    this.setCollectionOptions();
                    this.layout.loadData();
                });
            }
        }

        // this.$el.scroll(_.bind(function(){
        //     this.onScroll(this);
        // }, this));

    },

    /**
     * Init dashlet settings
     */
    initDashlet: function()
    {
        this.includeCurrentVisibility = false;
        this.includeOverdueVisibility = false;
        this.includeFutureVisibility = false;
        if(this.settings.get('visibility')) {
            _.each(this.settings.get('visibility'), function(visibilityValue){
                if(visibilityValue == 'current'){
                    this.includeCurrentVisibility = true;
                }else if(visibilityValue == 'overdue'){
                    this.includeOverdueVisibility = true;
                }else if(visibilityValue == 'future'){
                    this.includeFutureVisibility = true;
                }
            }, this);
        }

        if (!this.meta.config) {

            this.collection.on('add', this.bindCollectionAdd, this);
            this.collection.on('reset', this.bindCollectionReset, this);

            this._initMaxHeightTarget();
            this._initEvents();
            // this._initTabs();
            this._initTemplates();

            this.setCollectionOptions();


            this._initSettings();


            var collectionOptions = this.getCollectionOptions();
            //this.collection = app.data.createBeanCollection(this.module, [], collectionOptions);
            // this.context = this.context.getChildContext({
            //     forceNew: true,
            //     model: this.context.parent && this.context.parent.get('model'),
            //     collection: this.collection,
            //     //FIXME: name is temporary - special case for LinkedModel - SC-2550
            //     name: 'tabbed-dashlet',
            //     skipFetch: true
            // });

            // this.context.set('parentModule', this.module);
        }



        var options = {};
        var self = this;
        var refreshRate;

        options.limit = this.settings.get('limit') || this._defaultSettings.limit;
        this.settings.set('limit', options.limit);

        options.auto_refresh = this.settings.get('auto_refresh') || this._defaultSettings.auto_refresh;
        this.settings.set('auto_refresh', options.auto_refresh);

        options.enable_sticking_features = this.settings.get('enable_sticking_features') || this._defaultSettings.enable_sticking_features;
        this.settings.set('enable_sticking_features', options.enable_sticking_features);

        options = _.extend({}, this.context.get('collectionOptions'), options);
        this.context.set('collectionOptions', options);

        options.need_to_do_event_type_id = this.settings.get('need_to_do_event_type_id') || this._defaultSettings.need_to_do_event_type_id;
        this.settings.set('need_to_do_event_type_id', options.need_to_do_event_type_id);
        if(this.settings.get('need_to_do_event_type_id')) {
            var self = this;
            var needToDoEventTypeIds = this.settings.get('need_to_do_event_type_id');
            var findRelatedName = app.data.createBeanCollection('PX_NeedToDoEventTypes');
            findRelatedName.fetch({
                fields: ['name'], params: {filter: [{'id': {'$in': needToDoEventTypeIds}}]},
                complete: function () {
                    if (!self.disposed) {
                        if (findRelatedName.length > 0) {
                            self.settings.set('need_to_do_event_type_name', findRelatedName.pluck('name'), {silent: true});
                        }
                    }
                }
            });
        }

        options.dashlet_height = this.settings.get('dashlet_height') || this._defaultSettings.dashlet_height;
        this.settings.set('dashlet_height', options.dashlet_height);
        this.checkDashletHeight();

        if (!_.isEmpty(this.meta.currentFilterId) && _.isEmpty(this.meta.currentFilterId)) {
            this.settings.set('filter_id', this.meta.currentFilterId);
        }

        //UVAROVA
        if (this.meta.config) {
            this.listenTo(this.layout, 'init', this._addFilterComponent);
            this.listenTo(this.layout.context, 'filter:add', this.updateDashletFilterAndSave);
            this.listenTo(this.layout, 'dashletconfig:save', this._initializeSettings);
            this.layout.before('dashletconfig:save', function () {
                this.saveDashletFilter();
                this._initializeSettings();
                // NOTE: This prevents the drawer from closing prematurely.
                return false;
            }, this);
        } else if(this.needToDoEnabled){
            var filterId = this.settings.get('filter_id');
            if (!filterId || this.meta.preview) {
                this._displayDashlet();
                return;
            }

            var filters = app.data.createBeanCollection('Filters');
            filters.setModuleName('PX_NeedToDoEvents');
            filters.load({
                success: _.bind(function () {
                    if (this.disposed) {
                        return;
                    }
                    var filter = this.currentFilterObject = filters.collection.get(filterId);
                    var filterDef = filter && filter.get('filter_definition');
                    this._displayDashlet(filterDef);

                }, this),
                error: _.bind(function (err) {
                    if (this.disposed) {
                        return;
                    }
                    this._displayDashlet();
                }, this)
            });
        }

        this.layout.on('dashletconfig:save', function () {
            this._initializeSettings();
        }, this);
    },

    checkDashletHeight: function(){
        //check dashlet hight
        var dashletHeight = this.settings.get('dashlet_height');
        if(dashletHeight < 250){
            var contextModule = this.context.parent.get('module'),
                layoutType = this.context.parent.get('layout');
            if (contextModule != 'Home' && (layoutType == 'record' || layoutType == 'records')) {
                dashletHeight = 366;
            }else{
                dashletHeight = 466;
            }
            this.settings.set('dashlet_height', dashletHeight);
        }
    },

    _renderHtml: function() {
        if (this.meta.config) {
            app.view.View.prototype._renderHtml.call(this);
            return;
        }

        this.toolbarHtml = this._toolbarTpl(this);
        // this.tabsHtml = this._tabsTpl(this);

        // this._super('_renderHtml');
        app.view.View.prototype._renderHtml.call(this);

        this.addAdditionalFilters();
    },

    _getCollectionFilters: function(filterDef, index) {
        index = index || this.settings.get('activeTab')
        var collectionFilters = [],
            eventStatusList = this.settings.get('visibility');

        collectionFilters.push({
            'event_status': {
                '$in': eventStatusList
            } //index
        });

        var needToDoEventTypeIds = this.settings.get('need_to_do_event_type_id');
        filterDef = this.addQuickSearchFiltersToFilterDefinition(filterDef, needToDoEventTypeIds);

        return _.union(filterDef, collectionFilters);
    },

    disposeOldNtdEventsData: function(){
        this.disposeAllNeedToDoItems();
        // Clean up post container
        this.$el.find('.ntdv-dashlet-layout').html('');
        this.$el.find('.sticky-panel .sticky-group').html('');
        this.$el.find('.sticky-panel .sticky-item').html('');
    },

    refreshVisibilityValues: function(targetVisibilityName, visibilityFlag){
        var visibility = this.settings.get('visibility') || [],
            currentTabVisibilityIndex = _.indexOf(visibility, targetVisibilityName);
        if(visibilityFlag && currentTabVisibilityIndex < 0){
            visibility.push(targetVisibilityName);
        }else if(!visibilityFlag && currentTabVisibilityIndex >= 0){
            visibility.splice(currentTabVisibilityIndex, 1);
        }

        this.settings.set('visibility', visibility);
    },

    tabSwitcher: function(event) {
        this.disposeOldNtdEventsData();
        this.$el.find('.ntdv-dashlet-data-loading').show();
        this.$el.find('.block-footer').addClass('ntdv-dashlet-hide');

        var el = event.currentTarget;
        var index = $(el).data('value');

        $(el).toggleClass('active');
        //====================================================================
        if(index == 'current'){
            this.includeCurrentVisibility = !this.includeCurrentVisibility;
            this.refreshVisibilityValues(index, this.includeCurrentVisibility);
        }else if(index == 'overdue'){
            this.includeOverdueVisibility = !this.includeOverdueVisibility;
            this.refreshVisibilityValues(index, this.includeOverdueVisibility);
        }else if(index == 'future'){
            this.includeFutureVisibility = !this.includeFutureVisibility;
            this.refreshVisibilityValues(index, this.includeFutureVisibility);
        }
        //=====================================================================

        // if (index === this.settings.get('activeTab')) {
        //     return;
        // }

        var filterDef = this.context.get('collection').filterDef || [];

        this.settings.set('activeTab', index);
        this.saveCurrentDashletSettings();
        // this.collection = this.tabs[index].collection;
        ////////////////////////////////////////////////////////////////////

        var self = this,
            eventStatusKey = _.findIndex(filterDef, function(filter){
                return !_.isEmpty(filter['event_status']);
            });

        if(eventStatusKey !== -1){
            filterDef.splice(eventStatusKey, 1)
        }
        filterDef = this._getCollectionFilters(filterDef, index);

        this.collection.filterDef = filterDef;
        this.collection.fetch(this._getCollectionOptions());

        ////////////////////////////////////////////////////////////////////
        this.context.set('collection', this.collection);
        this.render();
    },

    saveCurrentDashletSettings: function(){
        var meta = this.meta,
            type = meta.componentType || 'view',
            model = this.layout.model;

        if(!meta) return;

        var conf = meta,
            dash = {
                context: {
                    module: model.get("module") || (meta.context ? meta.context.module : null),
                    link: model.get("link") || null
                }
            };
        delete conf.config;
        if(_.isEmpty(dash.context.module) && _.isEmpty(dash.context.link)) {
            delete dash.context;
        }
        dash[type] = conf;
        this.setDashletMetadata(dash);
    },

    setDashletMetadata: function(meta) {
        var metadata = this.layout.model.get("metadata"),
            component = this.getCurrentLayoutComponent(metadata, this.layout.meta.name);

        _.each(meta, function(value, key){
            this[key] = value;
        }, component);

        this.layout.model.set("metadata", app.utils.deepCopy(metadata), {silent: true});
        this.layout.model.trigger("change:layout");
        //auto save
        if(this.layout.model.mode === 'view') {
            this.layout.model.save(null, {
                silent: true,
                //NO alerts for this request
                showAlerts: false,
                success: _.bind(function() {
                    this.layout.model.unset('updated');
                }, this)
            });
        }
        return component;
    },

    getCurrentLayoutComponent: function(metadata, tracekey) {
        var position = tracekey;
        var component = metadata.dashlets;

        return component[position];
    },

    _createCollection: function(tab) {
        var collection = app.data.createBeanCollection('PX_NeedToDoEvents', [], this._getCollectionOptions());

        return collection;
    },

    bindCollectionAdd: function(model) {
        this.addNtdvRecordToStatistics(model);
        this.renderNeedToDoRow(model);
    },

    bindCollectionReset: function() {
        this.cleanUpStatistics();
        this.addNtdvCollectionToStatistics(this.collection);

        this.disposeAllNeedToDoItems();
        // Clean up post container
        this.$el.find('.ntdv-dashlet-layout').html('');
        this.$el.find('.sticky-panel .sticky-group').html('');
        this.$el.find('.sticky-panel .sticky-item').html('');

        this.collection.each(function(post) {
            this.renderNeedToDoRow(post);
        }, this);

        this.triggerNeedToDoAmountRefresh();
    },

    isDisabledForModule: function(contextModule){
        var isDisabled = _.indexOf(this.blacklistedModules, contextModule) >= 0;
        return isDisabled;
    },

    //UVAROVA
    updateDashletFilterAndSave: function(filterModel) {
        if(_.isEmpty(filterModel)){
            return;
        }
        // We need to save the filter ID on the dashlet model before saving
        // the dashlet.
        var id = filterModel.id || filterModel.get('id');
        this.settings.set('filter_id', id);
        this.dashModel.set('filter_id', id);

        var componentType = this.dashModel.get('componentType') || 'view';

        // Adding a new dashlet requires componentType to be set on the model.
        if (!this.dashModel.get('componentType')) {
            this.dashModel.set('componentType', componentType);
        }

        app.drawer.close(this.dashModel);
        // The filter collection is not shared amongst views and therefore
        // changes to this collection on different contexts (list views and
        // dashlets) need to be kept in sync.
        app.events.trigger('dashlet:filter:save', this.dashModel.get('module'));
    },

    _displayDashlet: function(filterDef) {

        // this.loadDataForTabs(this.tabs, filterDef);

        if (filterDef) {
            this._applyFilterDef(filterDef);
            this.context.reloadData({'recursive': false});
        }
        this._startAutoRefresh();
    },

    _applyFilterDef: function(filterDef) {
        if (filterDef) {

            filterDef = _.isArray(filterDef) ? filterDef : [filterDef];
            /**
             * Filter fields that don't exist either on vardefs or search definition.
             *
             * Special fields (fields that start with `$`) like `$favorite` aren't
             * cleared.
             *
             * TODO move this to a plugin method when refactoring the code (see SC-2555)
             * TODO we should support cleanup on all levels (currently made on 1st
             * level only).
             */
            var specialField = /^\$/,
                meta = app.metadata.getModule(this.module);
            filterDef = _.filter(filterDef, function(def) {
                var fieldName = _.keys(def).pop();
                return specialField.test(fieldName) || meta.fields[fieldName];
            }, this);

            filterDef = this._getCollectionFilters(filterDef);

            this.context.get('collection').filterDef = filterDef;
        }
    },

    _startAutoRefresh: function() {
        var refreshRate = parseInt(this.settings.get('auto_refresh'), 10);
        if (refreshRate) {
            this._stopAutoRefresh();
            this._timerId = setInterval(_.bind(function() {
                //this.context.resetLoadFlag();
                this.layout.loadData();
            }, this), refreshRate * 1000 * 60);
        }
    },

    _stopAutoRefresh: function() {
        if (this._timerId) {
            clearInterval(this._timerId);
        }
    },

    /**
     * This function adds the `dashablelist-filter` component to the layout
     * (dashletconfiguration), if the component doesn't already exist.
     */
    _addFilterComponent: function() {
        var filterComponent = this.layout.getComponent('dashablelist-filter');
        if (filterComponent) {
            return;
        }

        if(!_.isUndefined(this.layout['initComponents'])) {
            this.layout.initComponents([{
                layout: 'dashablelist-filter',
                loadModule: 'PX_NeedToDoEvents',
            }]);
        }else{
            this.layout._addComponentsFromDef([{
                layout: 'dashablelist-filter',
                loadModule: 'PX_NeedToDoEvents',
            }]);
        }
    },

    /**
     * Gets Filter Definition from metadata given a filter id
     */
    _getFilterDefFromMeta: function(id) {
        if (!id) {
            return;
        }

        var moduleMeta = app.utils.deepCopy(app.metadata.getModule('PX_NeedToDoEvents'));
        if (_.isObject(moduleMeta)) {

            var filters = app.data.createBeanCollection('Filters');
            filters.setModuleName('PX_NeedToDoEvents');
            filters.load({
                success: _.bind(function() {
                    if (this.disposed) {
                        return;
                    }
                    var filter = this.currentFilterObject = filters.collection.get(id);
                    return filter;
                }, this),
                error: _.bind(function(err) {
                    if (this.disposed) {
                        return;
                    }
                    this._displayDashlet();
                }, this)
            });
        }
    },

    getCollectionFetchLink: function(options, tabIndex, fetchType){
        tabIndex = tabIndex || this.settings.get('activeTab');
        var contextModule = this.context.parent.get('module'),
            layoutType = this.context.parent.get('layout'),
            modelId = this.context.parent.get('modelId'),
            url;

        if (contextModule == 'Home' && layoutType == 'record') {
            layoutType = 'need-to-do-events';
        }

        if(!_.isEmpty(fetchType) && fetchType == 'count'){
            contextModule = 'count/'+contextModule;
        }
        contextModule = 'pxntdv/' + contextModule;

        switch (layoutType) {
            case "need-to-do-events":
                //url = app.api.buildURL(contextModule, null, {}, options['params']);
                url = app.api.buildURL(contextModule + '/dashlet', 'PX_NeedToDoEvents', {}, options['params']);
                break;
            case "records":
                var params = _.extend({
                    parentFilters: this.context.parent.get('collection').filterDef//this.layout.collection.filterDef
                }, options['params']);
                url = app.api.buildURL(contextModule, 'PX_NeedToDoEvents', {}, params);
                break;
            case "record":
                url = app.api.buildURL(contextModule, 'need-to-do-events', {id: modelId, link: true}, options['params']);
                break;
        }
        return url;
    },

    /**
     * Set endpoint and the success callback for retrieving activities.
     */
    setCollectionOptions: function() {
        this.context.set('collectionOptions', this.getCollectionOptions());
    },

    _getCollectionOptions: function(){
        var self = this,
            endpoint = function(method, model, options, callbacks) {
                var url = self.getCollectionFetchLink(options);
                return app.api.call("read", url, null, callbacks);
            },
            limit = !_.isEmpty(this.settings) ? this.settings.get('limit') : this._defaultSettings.limit;
        return {
            endpoint: endpoint,
            success: function(collection) {
                self.$el.find('.ntdv-dashlet-data-loading').hide();
                self.$el.find('.block-footer').removeClass('ntdv-dashlet-hide');

                self.cleanUpStatistics();
                self.addNtdvCollectionToStatistics(collection);

                if(!_.isEmpty(self.$el)) {
                    self.$el.find('.block-footer').toggleClass('hide', (collection.length > 0));
                }
                collection.each(function(model) {
                    self.renderNeedToDoRow(model);
                });
                self.triggerNeedToDoAmountRefresh();
            },
            limit: limit
        };
    },

    getCollectionOptions: function(){
        var index = this.settings.get('activeTab') || 0;
        return this._getCollectionOptions();
    },

    getDefaultStatisticElement: function(){
        return {
            data: {},
            view: null,
            date: null,
            recordCount: 0 //,
            //collapsed: false
        };
    },
    getStatisticKey: function(date){
        var key = '';
        if (_.isString(date))
            date = this.getActionDate(date);
        if(_.isObject(date)/* && app.date.isDate(date)*/)
            key = date.format(this.statisticKeyFormat);
        return key;
    },
    addNtdvCollectionToStatistics: function(collection){
        var self = this;
        collection.each(function(model){
            self.addNtdvRecordToStatistics(model);
        });
    },
    addNtdvRecordToStatistics: function(model){
        var date = this.getActionDate(model.get(this.targetDatetimeFieldName)),
            statisticKey = this.getStatisticKey(date);
        this.needToDoStatistics[statisticKey] = this.needToDoStatistics[statisticKey] || this.getDefaultStatisticElement();
        this.needToDoStatistics[statisticKey]['data'][model.get('id')] = true;
        this.needToDoStatistics[statisticKey]['date'] = date;
    },
    triggerNeedToDoAmountRefresh: function(){
        _.each(this.needToDoStatistics, function(statistic, key){
            var amount = _.size(statistic.data);
            if(!_.isEmpty(statistic.view) && amount) {
                if(this.collection.next_offset > 0 && this.recordCountRefreshNeeded(statistic.date)){
                    if(!_.isEmpty(statistic['recordCount'])){
                        statistic.view.refreshAmount(amount, statistic.recordCount);
                    }else {
                        var self = this,
                            searchDate = statistic.date.format('YYYY-MM-DD'),
                            options = {
                                params: {
                                    'filter': _.isArray(this.collection.filterDef) ? this.collection.filterDef : [this.collection.filterDef],
                                    'fields': this.collection.fields,
                                    'count_for_date': searchDate
                                }
                            },
                            url = this.getCollectionFetchLink(options, null, 'count');
                        app.api.call('read', url, null,
                            {
                                success: _.bind(function (response) {
                                    statistic.view.refreshAmount(amount, response.record_count);
                                    self.needToDoStatistics[key]['recordCount'] = response.record_count;
                                    return;
                                }),
                                error: _.bind(function () {
                                    return;
                                })
                            });
                    }
                }else {
                    statistic.view.refreshAmount(amount);
                }
            }
        }, this);
    },

    recordCountRefreshNeeded: function(date){
        var lastDateInList = this.getLastDateInNeedToDoList();
        return lastDateInList.diff(date) == 0;
    },

    getLastDateInNeedToDoList: function(){
        var lastDate = null;
        _.each(this.needToDoStatistics, function(statistic){
            if(_.isEmpty(lastDate) || lastDate.diff(statistic.date) < 0){
                lastDate = statistic.date;
            }
        });
        return lastDate;
    },

    cleanUpStatistics: function(){
        //this.needToDoStatistics = {};
        _.each(this.needToDoStatistics, function(statistic, key){
            this.needToDoStatistics[key]['data'] = {};
            this.needToDoStatistics[key]['date'] = null;
        }, this);
    },

    getActionDate: function(date){
        var dateTime = app.date(date);
        return app.date({
            year: dateTime.year(),
            month: dateTime.month(),
            day: dateTime.date()
        });
    },

    resetStatisticsCount: function(){
        _.each(this.needToDoStatistics, function(statistic, key){
            this.needToDoStatistics[key]['recordCount'] = 0;
        }, this);
    },

    /**
     * This function is invoked by the `dashletconfig:save` event. It takes the
     * `currentFilterId` stored on the context, and saves it on the dashlet.
     *
     * @param {Bean} model The dashlet mo`del.
     */
    saveDashletFilter: function() {
        //this.layout.trigger('px-timeline-dashlet-filter:config:save');

        // Accessing the dashableconfiguration context.
        var context = this.layout.context;

        if (context.editingFilter) {
            // We are editing/creating a new filter
            if (!context.editingFilter.get('name')) {
                context.editingFilter.set('name', app.lang.get('LBL_DASHLET') +
                    ': ' + this.settings.get('label'));
            }
            // Triggers the save on `filter-rows` which then triggers
            // `filter:add` which then calls `updateDashletFilterAndSave`
            context.trigger('filter:create:save');
        } else {
            // We are saving a dashlet with a predefined filter
            var filterId = context.get('currentFilterId'),
                obj = {id: filterId};
            this.updateDashletFilterAndSave(obj);
        }

        this.resetStatisticsCount();
    },

    /**
     * Bind data changes and comments\post adding
     */
    bindDataChange: function() {
    },

    /**
     * Add posts to activity stream on data change
     *
     * @param model
     */
    prependPost: function(model) {
        var view = this.renderNeedToDoRow(model);
        view.$el.parent().prepend(view.$el);
    },

    cleanHtml: function(){
        this.$el.html(this.template());
    },

    loadData: function(options) {
        if (this.disposed || this.meta.config) {
            return;
        }

        // If activity streams are disabled for the current module on which the dashlet sits
        // then display a warning saying as much
        if (!this.needToDoEnabled) {
            this.template = app.template.getView(this.name + '.disabled', 'PX_NeedToDoEvents');
            this._super('_render', [options]);
            return;
        }

        options = _.extend({}, options, this.context.get('collectionOptions'));

        if (this.collection) {
            var filters = app.data.createBeanCollection('Filters');
            var self = this;
            filters.setModuleName('PX_NeedToDoEvents');
            filters.load({
                success: _.bind(function() {
                    if (this.disposed)
                        return;

                    var filter = this.currentFilterObject = filters.collection.get(this.settings.get('filter_id'));
                    if (filter)
                        options.filter = filter.get('filter_definition');

                    options.filter = self._getCollectionFilters(options.filter);

                    self.collection.fetch(options);

                }, this),
                error: _.bind(function(err) {
                    if (this.disposed) {
                        return;
                    }
                    this._displayDashlet();
                }, this)
            });
        }
    },

    /**
     * Render each ActivityStream model
     *
     * @param model
     * @return {Mixed}
     */
    renderNeedToDoRow: function(model) {
        var view,
            statisticKey;

        if (_.has(this.renderedNeedToDoItems, model.id)) {
            view = this.renderedNeedToDoItems[model.id];
        } else {

            var dateTime1 = app.date(model.get(this.targetDatetimeFieldName));
            var date1 = app.date({
                year: dateTime1.year(),
                month: dateTime1.month(),
                day: dateTime1.date()
            });
            statisticKey = this.getStatisticKey(date1);
            if(!_.isEmpty(this.lastProcessedDate)) {
                var dateTime2 = app.date(this.lastProcessedDate);
                var date2 = app.date({
                    year: dateTime2.year(),
                    month: dateTime2.month(),
                    day: dateTime2.date()
                });
            }
            if(!this.$el.find('.ntdv-group .ntdv-group-container[data-groupId="' + statisticKey + '"]').length &&
                (
                    _.isEmpty(this.lastProcessedDate) ||
                    date1.diff(date2, 'day', false) != 0
                )
            ) {
                var dateLineDelimiter = app.view.createView({
                    context: this.context,
                    name: "need-to-do-events-group",
                    //type: "need-to-do-events-group",
                    module: this.module,
                    layout: this,
                    model: model,
                    readonly: false,
                    dateLineDelimiter: true,
                    needToDoRows: [],
                    nopreview: true,
                    //nopreview: true  // hide preview button
                });
                this.$el.find('.ntdv-dashlet-layout').append(dateLineDelimiter.el);
                //this.addComponent(dateLineDelimiter);
                dateLineDelimiter.render();
                this.lastProcessedDate = model.get(this.targetDatetimeFieldName);


                this.needToDoStatistics[statisticKey] = this.needToDoStatistics[date1.format('YYYY-MM-DD')] || this.getDefaultStatisticElement();
                this.needToDoStatistics[statisticKey].view = dateLineDelimiter;
                this.needToDoStatistics[statisticKey].view.needToDoRows = [];
            }

            view = app.view.createView({
                context: this.context,
                name: "need-to-do-events-row",
                //type: "px-timeline-row",
                module: this.module,
                layout: this,
                model: model,
                nopreview: true  // hide preview button
            });

            statisticKey = this.getStatisticKey(date1);

            // Place view to dashlet layout container
            // this.$el.find()
            var groupEl = this.$el.find('.ntdv-group-container[data-groupId="' + statisticKey + '"]').closest('.ntdv-group');//.last();
            if(groupEl.length) {
                if(model.get('control_date_type') == 'date') {
                    groupEl.find('.ntdv-list').prepend(view.el);
                }else{
                    groupEl.find('.ntdv-list').append(view.el);
                }
                // this.$el.find('.ntdv-dashlet-layout').append(view.el);

                this.renderedNeedToDoItems[model.id] = view;
                view.render();
                if (!_.isEmpty(this.needToDoStatistics[statisticKey]) && !_.isEmpty(this.needToDoStatistics[statisticKey].view)) {
                    this.needToDoStatistics[statisticKey].view.needToDoRows.push(view);
                }
            }
        }

        return view;
    },

    /**
     * Skip rendering on pagination update
     * This is a hack to prevent dashlet re-render
     *
     * @param options
     */
    render: function(options)
    {
        if (!this.rendered) {
            this.rendered = true;
            this._super('render', [options]);

            // Append sub view - aka add component
            //this.$el.find('.omnibar-dashlet').append(this.omnibarView.el);
            //this.omnibarView.render();
        }

        this.toolBarHeight = this.$el.find('.dashlet-options').innerHeight();
        this.$el.find('.dashlet-unordered-list .tab-content').css('max-height', (parseInt(this.settings.get('dashlet_height')) - parseInt(this.toolBarHeight)) + 'px');
    },

    unbindData: function() {
        var model, collection;

        if (this.context.parent) {
            model = this.context.parent.get('model');
            collection = this.context.parent.get('collection');

            if (model) {
                model.off('change sync', null, this);
            }
            if (collection) {
                collection.off('sync', null, this);
            }
        }

        this._super('unbindData');
    },

    /**
     * Dispose all previously rendered activities
     */
    disposeAllNeedToDoItems: function() {
        var nonActivities = [];
        _.each(this._components, function(component) {
            if (component.name !== "need-to-do-events-row" && component.name !== "need-to-do-events-group" ) {
                //if (component.name !== 'px-timeline') {
                nonActivities.push(component);
            } else {
                component.dispose();
            }
        });
        this._components = nonActivities;
        this.renderedNeedToDoItems = {};
        this.lastProcessedDate = null;
        this.needToDoStatistics = {};
        this.plugins = ['Dashlet'];
    },

    paginate: function(options) {
        options = _.extend(options, this.getCollectionOptions(), {add: true});
        this.collection.paginate(options);
    },

    getLastGroupView: function(){
        var lastDate = null,
            view = null;
        _.each(this.needToDoStatistics, function(statistic){
            if(_.isEmpty(lastDate) || lastDate.diff(statistic.date) < 0){
                lastDate = statistic.date;
                view = statistic.view;
            }
        });
        return view;
    },

    needsAdditionalLoadingForLastGroup: function(){
        var view = this.getLastGroupView();
        if(view){
            return view.isCollapsed && !view.allNtdvRecordsLoaded();
        }
        return false;
    },

    downloadAllRecordsPerGroup: function(paginationFunction, options){
        var self = this,
            view = this.getLastGroupView(),
            actionDate = app.date(view.model.get(this.targetDatetimeFieldName)).format("YYYY-MM-DD"),
            loadedIds = [],
            filter;

        _.each(view.needToDoRows, function (view) {
            loadedIds.push(view.model.get('id'));
        })

        filter = [
            {control_date: actionDate},
            {
                id: {
                    '$not_in': loadedIds
                }
            }
        ];

        var url = app.api.buildURL('PX_NeedToDoEvents/filter/count', '', {}, {
            filter: filter,
            max_num: -1,
            order_by: ['control_date', 'DESC']
        });

        app.api.call('read', url, {},
            {
                success: _.bind(function (response) {
                    var recordCount = parseInt(response.record_count);
                    if(recordCount){
                        var limit = !_.isUndefined(options.limit) && !_.isNaN(options.limit) ? parseInt(options.limit) : 0;
                        options = _.extend(options, {limit: limit + recordCount});
                        paginationFunction(options);
                    }else{
                        paginationFunction(options);
                    }
                    return;
                }),
                error: _.bind(function () {
                    paginationFunction(options);
                    return;
                })
            });
    },

    _initializeSettings: function(model) {
        if (!this.dashModel.get('label')) {
            this.dashModel.set('label', this.settings.get('label'));
        }
    },

    _render: function() {
        this._super('_render');
         this.checkCurrentUserLicenseAccess();
    },

    checkCurrentUserLicenseAccess: function(){
        if(this.licenseStatus === null){
            this.licenseStatus = undefined;
            var url = app.api.buildURL('PX_NeedToDoEvents', 'license/validate');
            app.api.call('read', url, null, {
                success: _.bind(function(){
                    this.licenseStatus = true;
                    this.onLicenseValidation(true, '');
                }, this),
                error: _.bind(function (response) {
                    this.licenseStatus = false;
                    this.licenseErrorLabel = response.message;
                    this.onLicenseValidation(false, response.message);
                }, this)
            });
        }else if(this.licenseStatus === false || this.licenseStatus === true){
            this.onLicenseValidation(this.licenseStatus, this.licenseErrorLabel);
        }
    },

    onLicenseValidation: function(status, label){
        var blockFooterEl = this.$('.block-footer');
        if(blockFooterEl.length) {
            if (status) {
                this.$('.block-footer').html(app.lang.get('LBL_NO_DATA_AVAILABLE'));
            } else {
                this.$('.block-footer').html(this.licenseErrorLabel);
            }
        }
    },

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    targetGroupStick: null,
    targetNeedToDoStick: null,
    currentParentTop: 0,
    currentTargetGroupEl: null,
    currentTargetGroupTopOffset: 0,
    currentTargetNeedToDoEl: null,
    currentTargetNeedToDoTopOffset: 0,

    toggleGroupRecordsContainer: function(){
        if(!_.isEmpty(this.targetGroupStick)) {
            this.targetGroupStick.click();
        }
    },

    showCommentsInNeedToDoContainer: function(e){
        var el = e.currentTarget,
            isPressed = $(el).data('pressed');
        if(!_.isEmpty(this.targetNeedToDoStick)) {
            var needToDoContainerEl = this.targetNeedToDoStick;
            if($(el).hasClass('.empty-conversation-list'))
                this.targetNeedToDoStick.find('.show-comments-btn.empty-conversation-list').click();
            else
                this.targetNeedToDoStick.find('.show-comments-btn:not(.empty-conversation-list)').click();

            $(el).data('pressed', !isPressed);
        }
    },

    contextToggledInNeedToDoContainer: function(e){
        var el = e.currentTarget,
            isPressed = $(el).data('pressed');
        if(!_.isEmpty(this.targetNeedToDoStick)) {
            this.targetNeedToDoStick.find('.context-btn').click();
            $(el).data('pressed', !isPressed);

            if(!this.needToDoPanelHasAdditionalContainers(this.targetNeedToDoStick.closest('.ntdv-container')))
                this.clearUpStickyItem();
        }
    },

    enableScrolling: function(){
        var mainPaneScrollEl = this.$el.find('.tab-content');
        if(!_.isEmpty(mainPaneScrollEl)) {
            mainPaneScrollEl.on("scroll", _.bind(this.onScroll, this));
        }
    },

    disableScrolling: function(){
        this.$el.off("scroll");
    },

    getStickyGroupEl: function(){
        if(!_.isEmpty(this.$el.find('.sticky-group'))) {
            return this.$el.find('.sticky-group');
        }

        return null;
    },

    getStickyItemEl: function(){
        if(!_.isEmpty(this.$el.find('.sticky-item'))) {
            return this.$el.find('.sticky-item');
        }

        return null;
    },

    getCurrentParentEl: function(){
        return this.$el.find('.tab-content');
    },

    setCurrentParentTop: function(){
        var parentEl = this.getCurrentParentEl(),
            parent = parentEl[0],
            additionalHeight = this.getAdditionalHeightFromMainePane(),
            scrollTop = this.getNeedToDoOffsetHeight();

        this.currentParentTop = parent.offsetTop + scrollTop + parent.scrollTop;

        // if(additionalHeight >= scrollTop)
        //     return;

        while(parent.offsetParent) {
            parent = parent.offsetParent;
            this.currentParentTop += (parent.offsetTop);
        }

        // this.currentParentTop -= additionalHeight;
    },

    getCurrentParentTop: function(){
        this.setCurrentParentTop();
        return this.currentParentTop;
    },

    onScroll: function(){

        if(this.disableScroll)
            return;

        // this.currentTargetGroupEl = null;
        // this.currentTargetGroupTopOffset = 0;
        this.scrollTop = this.getNeedToDoOffsetHeight();
        this.additionalHeightFromMainePane = this.getAdditionalHeightFromMainePane();
        this.setCurrentParentTop();

        var scrollTop = this.getNeedToDoOffsetHeight(),
            additionalHeight = this.getAdditionalHeightFromMainePane();


        if(additionalHeight < scrollTop) {
            this.stickButtons();
        }else{
            this.clearUpStickyGroup();
            this.clearUpStickyItem();
        }

        // this.readMessages();
    },

    stickButtons: function(){
        var additionalHeight = this.additionalHeightFromMainePane,
            targetGroup = this.getGroupElementFromTopViewport(additionalHeight);

        if(_.isEmpty(targetGroup) || targetGroup.find('.ntdv-group-container').hasClass('collapsed')) {
            this.clearUpStickyGroup();
            this.clearUpStickyItem();
            return;
        }

        var stickyGroupEl = this.getStickyGroupEl();
        if(stickyGroupEl) {
            this.currentTargetGroupEl = targetGroup;
            stickyGroupEl
                .html(targetGroup.find('.ntdv-group-container').html())
                .data('id', targetGroup.find('.ntdv-group-container').data('id'))
                .show();
        }
        this.targetGroupStick = targetGroup.find('.ntdv-group-container');


        //TIMELINE ROW
        var targetNeedToDoElement = this.getTargetNeedToDoFromTopViewport(targetGroup, additionalHeight);

        if(_.isEmpty(targetNeedToDoElement)) {
            this.clearUpStickyItem();
            return;
        }

        this.currentTargetNeedToDoEl = targetNeedToDoElement;

        this.clearUpStickyItem();
        var targetNeedToDoPanelEl = this.stickNeedToDoButton(targetNeedToDoElement, targetGroup, additionalHeight);
        if(!_.isEmpty(targetNeedToDoPanelEl)) {
            // this.currentTargetNeedToDoEl = targetNeedToDoPanelEl;
            this.targetNeedToDoStick = targetNeedToDoPanelEl;

            var stickyItemEl = this.getStickyItemEl();
            if(stickyItemEl) {
                stickyItemEl.html(targetNeedToDoPanelEl.html()).show();
            }

            var targetNeedToDoContainerName = targetNeedToDoPanelEl.closest('.ntdv-container').attr('name');
            if(stickyItemEl) {
                stickyItemEl.attr('name', targetNeedToDoContainerName);
            }
        }
        // else {
        //     this.clearUpStickyItem();
        // }
    },

    clearUpStickyGroup: function(){
        this.targetGroupStick = null;
        this.currentTargetGroupEl = null;
        this.currentTargetGroupTopOffset = 0;
        var stickyGroupEl = this.getStickyGroupEl();
        if(stickyGroupEl) {
            stickyGroupEl.html('').hide().data('id', '');
        }
    },

    clearUpStickyItem: function(){
        this.currentTargetNeedToDoEl = null;
        this.currentTargetNeedToDoTopOffset = 0;
        this.targetNeedToDoStick = null;
        var stickyItemEl = this.getStickyItemEl();
        if(stickyItemEl) {
            stickyItemEl.html('').hide().data('name', '');
        }
    },

    getAdditionalGroupHeight: function(){
        var additionalHeight = 0;
        return additionalHeight;
    },

    getNeedToDoOffsetHeight: function(){
        var mainPaneEl = this.$el;
        if(!_.isEmpty(mainPaneEl)){
            return mainPaneEl[0].scrollTop;
        }
        return 0;
    },

    setNeedToDoOffsetHeight: function(offsetHeight){
        var mainPaneEl = this.$el;
        if(offsetHeight < 0){
            offsetHeight = 0
        }
        if(!_.isEmpty(mainPaneEl)){
            mainPaneEl[0].scrollTop = offsetHeight;
        }
    },

    needToDoPanelHasAdditionalContainers: function(needToDoContainer){
        if(_.isEmpty(needToDoContainer)){
            return false;
        }
        var contextEl = needToDoContainer.find('.ntdv-context-container'),
            commentItem = needToDoContainer.find('.ntdv-comment-container');

        if(
            (_.isEmpty(contextEl) || !contextEl.length || contextEl[0].offsetHeight <=0) &&
            (_.isEmpty(commentItem) || !commentItem.length || commentItem[0].offsetHeight <= 0)
        ){
            return false;
        }
        return true;
    },

    stickNeedToDoButton: function(needToDoContainer, groupContainer, additionalHeight){
        var $el = this.$el;

        if(!this.needToDoPanelHasAdditionalContainers(needToDoContainer)) {
            return;
        }

        var $stickyEl = needToDoContainer.find('.ntdv-panel'),
            // $stickyElStub = $stickyEl.closest('.ntdv-panel-stub'),

            stickyGroupEl = this.getStickyGroupEl(),
            stickyGroupElHeight = (stickyGroupEl ? stickyGroupEl[0].offsetHeight : 0),

            // stickyTimelineElHeight = $stickyEl[0].offsetHeight + stickyGroupElHeight,

            topElViewPort = this.isNeedToDoElementInViewport(needToDoContainer[0], $stickyEl[0], $el[0], additionalHeight - stickyGroupElHeight),

            scrollTop = this.getNeedToDoOffsetHeight();


        if(!topElViewPort.isTopVisible && !topElViewPort.isAbove){
            var topPosition,
                prevOffset = 0,
                $previousDialogContainer = needToDoContainer.prev('.ntdv-row-item');

            while($previousDialogContainer.length){
                prevOffset += $previousDialogContainer[0].offsetHeight;
                $previousDialogContainer = $previousDialogContainer.prev('.ntdv-row-item')
            }

            var $previousGroupContainer = groupContainer.prev('.ntdv-group');
            while($previousGroupContainer.length){
                prevOffset += $previousGroupContainer[0].offsetHeight;
                $previousGroupContainer = $previousGroupContainer.prev('.ntdv-group')
            }
            topPosition = scrollTop - prevOffset /*- stickyGroupElHeight*/ + additionalHeight;
            if(topPosition > 0){
                return $stickyEl;
            }
        }
        return null;
    },

    getTargetNeedToDoContainerPosition: function(needToDoContainer, groupContainer){
        var $el = this.$el,
            topPosition = 0;

        if(!this.needToDoPanelHasAdditionalContainers(needToDoContainer)) {
            return topPosition;
        }

        var additionalHeight = this.getAdditionalHeightFromMainePane(),
            $stickyEl = needToDoContainer.find('.ntdv-panel'),
            // $stickyElStub = $stickyEl.closest('.ntdv-panel-stub'),
            // $topEl = needToDoContainer.find('.ntdv-panel-top'),
            // $bottomEl = needToDoContainer.find('.ntdv-panel-bottom'),
            // topElViewPort = this.isElementInViewport($topEl[0], $el[0]),
            // bottomElViewPort = this.isElementInViewport($bottomEl[0], $el[0]),
            stickyGroupEl = this.getStickyGroupEl(),
            stickyGroupElHeight = (stickyGroupEl ? stickyGroupEl[0].offsetHeight : 0),

            topElViewPort = this.isNeedToDoElementInViewport(needToDoContainer[0], $stickyEl[0], $el[0], additionalHeight - stickyGroupElHeight)
        ;

        // if(!topElViewPort.isTopVisible && !topElViewPort.isBelow && !bottomElViewPort.isAbove){
        if(!topElViewPort.isTopVisible && !topElViewPort.isAbove){
            var prevOffset = 0,
                $previousDialogContainer = needToDoContainer.prev('.ntdv-row-item');

            while($previousDialogContainer.length){
                prevOffset += $previousDialogContainer[0].offsetHeight;
                $previousDialogContainer = $previousDialogContainer.prev('.ntdv-row-item')
            }

            var $previousGroupContainer = groupContainer.prev('.ntdv-group');
            while($previousGroupContainer.length){
                prevOffset += $previousGroupContainer[0].offsetHeight;
                $previousGroupContainer = $previousGroupContainer.prev('.ntdv-group')
            }
            topPosition = prevOffset + /*18 +*/ additionalHeight;
            return topPosition;
        }
        return topPosition;
    },

    disableScroll: false,

    updateScrollPositionOnToggleNeedToDoDetails: function(elementOffset){
        this.disableScroll = true;
        this.setNeedToDoOffsetHeight(elementOffset);
        this.disableScroll = false;

        this.clearUpStickyItem();
    },

    updateScrollPositionOnToggleGroup: function(element, elementHeight, elementOffset){
        this.disableScroll = true;
        this.setNeedToDoOffsetHeight(elementOffset);
        this.disableScroll = false;

        this.clearUpStickyGroup();
    },

    stickNeedToDoPanel: function(ntdvPanelEl){
        ntdvPanelEl.addClass('sticky')
    },

    unstickNeedToDoPanel: function(ntdvPanelEl){
        ntdvPanelEl.removeClass('sticky').removeClass('sliding-out');
    },

    getGroupElementFromTopViewport: function(additionalHeight){
        var //parent = this.$el[0],
            // scrollTop = this.getNeedToDoOffsetHeight(),
            // parentTop = parent.offsetTop + scrollTop,
            targetElement,
            elements = this.$el.find('.ntdv-group'),
            elementsPosition = 0,
            elTopOffset = 0,
            total = 0
        ;

        if(!elements.length /* || (additionalHeight) >= scrollTop*/)
            return;

        // while(parent.offsetParent) {
        //     parent = parent.offsetParent;
        //     parentTop += (parent.offsetTop);
        // }

        var el = elements[0];
        while(el.offsetParent) {
            el = el.offsetParent;
            elTopOffset += (el.offsetTop);
        }

        this.currentTargetGroupTopOffset = elTopOffset - 11 + additionalHeight;

        _.each(elements, function(elem, key){
            if(!_.isEmpty(targetElement)){
                return;
            }
            var groupContainerEl = $(elem).find('.ntdv-group-container'),
                groupContainerHeight = 0;
            if(!_.isEmpty(groupContainerEl)){
                groupContainerHeight = groupContainerEl[0].offsetHeight;
            }
            elementsPosition += elem.offsetHeight;

            total = this.currentTargetGroupTopOffset + elementsPosition + groupContainerHeight;

            if((total) > (this.currentParentTop /* - additionalHeight*/)) {

                this.currentTargetGroupTopOffset +=  elementsPosition + groupContainerHeight - elem.offsetHeight;

                targetElement = $(elem);
                return;
            }
        }, this);

        return targetElement;
    },


    getDateGroupContainerTopPosition: function(targetGroupContainer){
        var $el = this.$el,
            topPosition = 0;
        if(_.isEmpty(targetGroupContainer) || !targetGroupContainer.find('.ntdv-group-container:not(.toggled)').length){
            return 0;
        }
        var additionalHeight = this.getAdditionalHeightFromMainePane(),
            $stickyEl = targetGroupContainer.find('.ntdv-group-container'),
            topElViewPort = this.isElementInViewport(targetGroupContainer[0], $stickyEl[0], $el[0], additionalHeight);

        if(!topElViewPort.isTopVisible && !topElViewPort.isAbove){
            var prevOffset = 0,
                $previousDialogContainer = targetGroupContainer.prev('.ntdv-group');
            while($previousDialogContainer.length){
                prevOffset += $previousDialogContainer[0].offsetHeight;
                $previousDialogContainer = $previousDialogContainer.prev('.ntdv-group')
            }

            topPosition = prevOffset + additionalHeight;
        }
        return topPosition;
    },

    unglueGroupElement: function(element){
        if(!element.hasClass('sticky'))
            return;

        element.removeClass('sticky')
        element.css('top', '0px');
    },

    getTargetNeedToDoFromTopViewport: function(targetGroup, additionalHeight){
        var targetNeedToDoElement,
            elements = targetGroup.find('.ntdv-row-item'),
            elementsPosition = 0,
            elTopOffset = 0,
            total = 0;

        if(!elements.length) {
            return;
        }

        var el = elements[0];
        while(el.offsetParent) {
            el = el.offsetParent;
            elTopOffset += (el.offsetTop);
        }

        this.currentTargetNeedToDoTopOffset = elTopOffset + additionalHeight + 11;

        _.each(elements, function(elem, key){
            if(!_.isEmpty(targetNeedToDoElement) && targetNeedToDoElement.length) {
                return;
            }else {
                elementsPosition += elem.offsetHeight;
                total = (elementsPosition + this.currentTargetNeedToDoTopOffset);

                if (total >= this.currentParentTop) {
                    this.currentTargetNeedToDoTopOffset += elementsPosition - elem.offsetHeight;
                    targetNeedToDoElement = $(elem);
                }
            }
        }, this);



        return targetNeedToDoElement;
    },

    unglueTimlineElement: function(element){
        // if(!element.hasClass('sticky'))
        //     return;

        element.removeClass('sticky').removeClass('sliding-out');
        element.css('top', '0px');
    },

    isElementInViewport: function(containerEl, targetEl, parentEl, additionalHeight){
        var top = containerEl.offsetTop - 0,
            height = containerEl.offsetHeight,
            panelHeight = targetEl.offsetHeight;

        var scrollTop = this.getNeedToDoOffsetHeight(),
            parentTop = parentEl.offsetTop + scrollTop,
            parentHeight = parentEl.offsetHeight;

        while(containerEl.offsetParent) {
            containerEl = containerEl.offsetParent;
            top += (containerEl.offsetTop);
        }
        while(parentEl.offsetParent) {
            parentEl = parentEl.offsetParent;
            parentTop += (parentEl.offsetTop);
        }

        top += additionalHeight;

        // top += 311 - 45;
        var isInViewPort = {
            isTopVisible : (top) >= (parentTop),
            isBottomVisible: (top + height - panelHeight) <= (parentTop),
            isAbove: (top + height - panelHeight) <= parentTop,
            isBelow: top >= (parentTop + parentHeight),
            top: top,
            bottom: (top + height)
        };
        return isInViewPort;
    },

    isNeedToDoElementInViewport: function(containerEl, targetEl, parentEl, additionalHeight){
        var top = containerEl.offsetTop - 0,
            height = containerEl.offsetHeight,
            panelHeight = targetEl.offsetHeight;

        var scrollTop = this.getNeedToDoOffsetHeight(),
            parentTop = parentEl.offsetTop + scrollTop,
            parentHeight = parentEl.offsetHeight;

        while(containerEl.offsetParent) {
            containerEl = containerEl.offsetParent;
            top += (containerEl.offsetTop);
        }
        while(parentEl.offsetParent) {
            parentEl = parentEl.offsetParent;
            parentTop += (parentEl.offsetTop);
        }
        top += additionalHeight;
        var isInViewPort = {
            isTopVisible : (top + 10) >= (parentTop),
            isBottomVisible: (top + height - panelHeight) <= (parentTop),
            isAbove: (top + height - panelHeight) <= parentTop,
            isBelow: top >= (parentTop + parentHeight),
            top: top,
            bottom: (top + height)
        };
        return isInViewPort;
    },

    getAdditionalHeightFromMainePane: function(){
        return 0;
    },

    addAdditionalFilters: function(){
        var fieldValues = this.settings.get('need_to_do_event_type_id');
        this.renderQuickSearchEventTypeField(fieldValues);
    },

    renderQuickSearchEventTypeField: function(fieldValues){
        var self = this,
            field, fieldContainer, fieldEl,
            fieldName = 'event_type_name',
            fieldLabel = 'LBL_EVENT_TYPE_NAME',
            model = app.data.createBean('PX_NeedToDoEvents'),
            fieldDefs = model.fields[fieldName];

        fieldDefs.auto_populate = true;
        fieldDefs.isMultiSelect = true;
        fieldDefs.required = false;
        fieldDefs.readonly = false;
        fieldDefs.placeholder = app.lang.get("LBL_SEARCH_SELECT");

        field = this.createField(model, fieldDefs);
        fieldContainer = this.$el.find('.ntdv-additional-filter');
        fieldEl = $(field.getPlaceholder().string);
        fieldEl.prependTo(fieldContainer);

        if(!_.isEmpty(fieldValues)) {
            var findRelatedName = app.data.createBeanCollection('PX_NeedToDoEventTypes');
            findRelatedName.fetch({
                fields: [fieldDefs.rname], params: {filter: [{'id': {'$in': fieldValues}}]},
                complete: function () {
                    if (!self.disposed) {
                        if (findRelatedName.length > 0) {
                            model.set(fieldDefs.id_name, findRelatedName.pluck('id')/*, {silent: true}*/);
                            model.set(fieldName, findRelatedName.pluck(fieldDefs.rname)/*, {silent: true}*/);
                        }
                    }
                }
            });
        }

        this._renderField(field, fieldEl);

        model.on('change:event_type_id', _.bind(function(model, newValue){
            this.settings.set('need_to_do_event_type_id', model.get('event_type_id'));
            this.meta['need_to_do_event_type_id'] = model.get('event_type_id');
            this.meta['need_to_do_event_type_name'] = model.get('event_type_name');
            this.saveCurrentDashletSettings();

            var filterDef = this.context.get('collection').filterDef || [];
            this.collection.filterDef = this._getCollectionFilters(filterDef);
            this.collection.fetch(this._getCollectionOptions());
            this.context.set('collection', this.collection);
            this.render();
        }, this));
    },

    createField: function(model, def) {
        var obj = {
            meta: {
                view: 'edit'
            },
            def: def,
            model: model,
            context: app.controller.context,
            viewName: 'edit',
            view: this
        };

        var field = app.view.createField(obj);
        field.action = 'detail';
        return field;
    },

    // saveQuickSearchFilter: function(needToDoEventTypeIds) {
    //     var context = this.layout.context;
    //
    //     var self = this;
    //
    //     if(_.isEmpty(this.currentFilterObject)){
    //         this.currentFilterObject = app.data.createBean('Filters');
    //     }
    //
    //     var newFilterDefinition = this.addQuickSearchFiltersToFilterDefinition(this.currentFilterObject.get('filter_definition'), needToDoEventTypeIds);
    //     var newFilterTemplate = this.addQuickSearchFiltersToFilterDefinition(this.currentFilterObject.get('filter_template'), needToDoEventTypeIds);
    //     this.currentFilterObject.set('filter_definition', newFilterDefinition);
    //     this.currentFilterObject.set('filter_template', newFilterTemplate);
    //
    //     this.currentFilterObject.save({}, {
    //         success: function(filterModel) {
    //             var id = filterModel.id || filterModel.get('id');
    //             self.settings.set('filter_id', id);
    //             self.dashModel.set('filter_id', id);
    //         },
    //         showAlerts: false
    //     });
    // },

    addQuickSearchFiltersToFilterDefinition: function(filterDefinition, eventTypesIds){
        eventTypesIds = eventTypesIds || [];

        if(!_.isEmpty(this.currentFilterObject) && _.isObject(this.currentFilterObject.get('filter_definition')) && !_.isArray(this.currentFilterObject.get('filter_definition'))){
            var objectDefinition = filterDefinition;
            filterDefinition = [];
            _.each(this.currentFilterObject.get('filter_definition'), function(predefinedFilterVal, predefinedFilterKey){
                var predefinedFilterItem = {};
                predefinedFilterItem[predefinedFilterKey] = predefinedFilterVal;
                filterDefinition.push(predefinedFilterItem);
            });
        }
        // var existsFilterByEventType = this.currentFilterHasFilterByEventType();
        var addedEventTypeIds = false;
        var level = 1;
        // filterDefinition = filterDefinition || [];
        _.each(filterDefinition, function(filter, key){
            _.each(filter, function(values, fieldName){
                if(fieldName == 'event_type_id' && !_.isUndefined(values['$in'])) {
                    var eventTypeIdsFromTemplate = this.getEventTypeIdsFromFilterTemplate(level);

                    addedEventTypeIds = true;
                    // if(!_.isEmpty(eventTypesIds) || !existsFilterByEventType) {
                    // filterDefinition[key][fieldName]['$in'] = eventTypesIds;
                    // }
                    if(!_.isEmpty(eventTypeIdsFromTemplate)) {
                        filterDefinition[key][fieldName]['$in'] = eventTypeIdsFromTemplate;
                    }else{
                        filterDefinition[key][fieldName]['$in'] = [];
                    }

                    if(!_.isEmpty(eventTypesIds)) {
                        _.each(eventTypesIds, function(eventTypeId){
                            if(_.isUndefined(_.find(filterDefinition[key][fieldName]['$in'], function(val){ return val == eventTypeId }))) {
                                filterDefinition[key][fieldName]['$in'].push(eventTypeId);
                            }
                        });
                        // filterDefinition[key][fieldName]['$in'] = filterDefinition[key][fieldName]['$in'].concat(eventTypesIds);
                    }
                    level++;
                }
            }, this);
        }, this)

        if(!addedEventTypeIds && _.isArray(filterDefinition)){
            filterDefinition.push({
                'event_type_id': {
                    '$in': eventTypesIds
                }
            });
        }

        return filterDefinition;
    },

    getEventTypeIdsFromFilterTemplate: function(targetLevel){
        if(!_.isEmpty(this.currentFilterObject) && this.currentFilterObject.get('id') !== 'all_records'){
            var filterTemplate = this.currentFilterObject.get('filter_template'),
                level = 1,
                eventTypeIds = [];

            _.each(filterTemplate, function (filter, key) {
                _.each(filter, function (values, fieldName) {
                    if (fieldName == 'event_type_id' && !_.isEmpty(values['$in'])) {
                        if(level == targetLevel){
                            eventTypeIds = values['$in'];
                        }
                        level++;
                    }
                });
            })
        }
        return eventTypeIds;
    },

    // currentFilterHasFilterByEventType: function(){
    //     var hasFilters = false;
    //     if(!_.isEmpty(this.currentFilterObject) && this.currentFilterObject.get('id') !== 'all_records'){
    //         var filterDefinition = this.currentFilterObject.get('filter_template');
    //
    //         _.each(filterDefinition, function (filter, key) {
    //             _.each(filter, function (values, fieldName) {
    //                 if (fieldName == 'event_type_id' && !_.isEmpty(values['$in'])) {
    //                     hasFilters = true;
    //                 }
    //             });
    //         })
    //     }
    //
    //     return hasFilters;
    // }

})

